diff --git a/src/appimagetool.c b/src/appimagetool.c
index 48fe9c04..73f12a42 100644
--- a/src/appimagetool.c
+++ b/src/appimagetool.c
@@ -1121,176 +1121,177 @@ main (int argc, char *argv[])
 
                 if (pclose(fp) != 0) {
                     fprintf(stderr, "ERROR: %s command did not succeed, could not sign, continuing\n", using_gpg ? "gpg" : "gpg2");
-                    return 0;
-                }
+                } else {
 
-                fp = NULL;
+                    fp = NULL;
 
-                FILE* destinationfp = fopen(destination, "r+");
+                    FILE* destinationfp = fopen(destination, "r+");
 
-                // calculate signature
-                {
-                    unsigned long sig_offset = 0;
-                    unsigned long sig_length = 0;
+                    // calculate signature
+                    {
+                        unsigned long sig_offset = 0;
+                        unsigned long sig_length = 0;
 
-                    bool rv = appimage_get_elf_section_offset_and_length(destination, ".sha256_sig", &sig_offset, &sig_length);
+                        bool rv = appimage_get_elf_section_offset_and_length(destination, ".sha256_sig", &sig_offset,
+                                                                             &sig_length);
 
-                    if (!rv || sig_offset == 0 || sig_length == 0) {
-                        die("Could not find section .sha256_sig in runtime");
-                    }
+                        if (!rv || sig_offset == 0 || sig_length == 0) {
+                            die("Could not find section .sha256_sig in runtime");
+                        }
 
-                    if (verbose) {
-                        printf("sig_offset: %lu\n", sig_offset);
-                        printf("sig_length: %lu\n", sig_length);
-                    }
+                        if (verbose) {
+                            printf("sig_offset: %lu\n", sig_offset);
+                            printf("sig_length: %lu\n", sig_length);
+                        }
 
-                    if (sig_offset == 0) {
-                        die("Could not determine offset for signature");
-                    }
+                        if (sig_offset == 0) {
+                            die("Could not determine offset for signature");
+                        }
 
-                    if (destinationfp == NULL)
-                        die("Not able to open the destination file for writing, aborting");
+                        if (destinationfp == NULL)
+                            die("Not able to open the destination file for writing, aborting");
 
-                    // if(strlen(updateinformation)>sig_length)
-                    //     die("signature does not fit into segment, aborting");
+                        // if(strlen(updateinformation)>sig_length)
+                        //     die("signature does not fit into segment, aborting");
 
-                    fseek(destinationfp, sig_offset, SEEK_SET);
+                        fseek(destinationfp, sig_offset, SEEK_SET);
 
-                    FILE* ascfilefp = fopen(ascfile, "rb");
+                        FILE* ascfilefp = fopen(ascfile, "rb");
 
-                    if (ascfilefp == NULL) {
-                        die("Not able to open the asc file for reading, aborting");
-                    }
+                        if (ascfilefp == NULL) {
+                            die("Not able to open the asc file for reading, aborting");
+                        }
 
-                    static const int bufsize = 1024;
-                    char buffer[bufsize];
+                        static const int bufsize = 1024;
+                        char buffer[bufsize];
 
-                    size_t totalBytesRead = 0;
+                        size_t totalBytesRead = 0;
 
-                    while (!feof(ascfilefp)) {
-                        size_t bytesRead = fread(buffer, sizeof(char), bufsize, ascfilefp);
-                        totalBytesRead += bytesRead;
+                        while (!feof(ascfilefp)) {
+                            size_t bytesRead = fread(buffer, sizeof(char), bufsize, ascfilefp);
+                            totalBytesRead += bytesRead;
 
-                        if (totalBytesRead > sig_length) {
-                            die("Error: cannot embed key in AppImage: size exceeds reserved ELF section size");
-                        }
+                            if (totalBytesRead > sig_length) {
+                                die("Error: cannot embed key in AppImage: size exceeds reserved ELF section size");
+                            }
 
-                        size_t bytesWritten = fwrite(buffer, sizeof(char), bytesRead, destinationfp);
+                            size_t bytesWritten = fwrite(buffer, sizeof(char), bytesRead, destinationfp);
 
-                        if (bytesRead != bytesWritten) {
-                            char message[128];
-                            sprintf(message, "Bytes read and written differ: %lu != %lu", (long unsigned) bytesRead,
-                                (long unsigned) bytesWritten);
-                            die(message);
+                            if (bytesRead != bytesWritten) {
+                                char message[128];
+                                sprintf(message, "Bytes read and written differ: %lu != %lu", (long unsigned) bytesRead,
+                                        (long unsigned) bytesWritten);
+                                die(message);
+                            }
                         }
-                    }
 
-                    fclose(ascfilefp);
-                    if (g_file_test(digestfile, G_FILE_TEST_IS_REGULAR))
-                        unlink(digestfile);
+                        fclose(ascfilefp);
+                        if (g_file_test(digestfile, G_FILE_TEST_IS_REGULAR))
+                            unlink(digestfile);
 
-                    if (sign_key == NULL || strlen(sign_key) > 0) {
-                        // read which key was used to sign from signature
-                        sprintf(command, "%s --batch --list-packets %s", gpg2_path, ascfile);
+                        if (sign_key == NULL || strlen(sign_key) > 0) {
+                            // read which key was used to sign from signature
+                            sprintf(command, "%s --batch --list-packets %s", gpg2_path, ascfile);
 
-                        fp = popen(command, "r");
+                            fp = popen(command, "r");
 
-                        if (fp == NULL)
-                            die("Failed to call gpg[2] to detect signature's key ID");
+                            if (fp == NULL)
+                                die("Failed to call gpg[2] to detect signature's key ID");
 
-                        while (!feof(fp)) {
-                            size_t bytesRead = fread(buffer, sizeof(char), bufsize, fp);
+                            while (!feof(fp)) {
+                                size_t bytesRead = fread(buffer, sizeof(char), bufsize, fp);
 
-                            char* keyid_pos = strstr(buffer, "keyid");
+                                char* keyid_pos = strstr(buffer, "keyid");
 
-                            if (keyid_pos == NULL)
-                                continue;
+                                if (keyid_pos == NULL)
+                                    continue;
 
-                            char* keyIDBegin = keyid_pos + strlen("keyid ");
-                            char* endOfKeyID = strstr(keyIDBegin, "\n");
+                                char* keyIDBegin = keyid_pos + strlen("keyid ");
+                                char* endOfKeyID = strstr(keyIDBegin, "\n");
 
-                            sign_key = calloc(endOfKeyID - keyIDBegin, sizeof(char));
-                            memcpy(sign_key, keyIDBegin, endOfKeyID - keyIDBegin);
-                        }
+                                sign_key = calloc(endOfKeyID - keyIDBegin, sizeof(char));
+                                memcpy(sign_key, keyIDBegin, endOfKeyID - keyIDBegin);
+                            }
 
-                        // read rest of process input to avoid broken pipe error
-                        while (!feof(fp)) {
-                            fread(buffer, sizeof(char), bufsize, fp);
-                        }
+                            // read rest of process input to avoid broken pipe error
+                            while (!feof(fp)) {
+                                fread(buffer, sizeof(char), bufsize, fp);
+                            }
 
-                        int retval = pclose(fp);
-                        fp = NULL;
+                            int retval = pclose(fp);
+                            fp = NULL;
+
+                            if (retval != 0)
+                                die("Failed to call gpg[2] to detect signature's key ID");
+                        }
 
-                        if (retval != 0)
-                            die("Failed to call gpg[2] to detect signature's key ID");
+                        if (g_file_test(ascfile, G_FILE_TEST_IS_REGULAR))
+                            unlink(ascfile);
                     }
 
-                    if (g_file_test(ascfile, G_FILE_TEST_IS_REGULAR))
-                        unlink(ascfile);
-                }
+                    // export key and write into section
+                    {
+                        sprintf(command, "%s --batch --export --armor %s", gpg2_path, sign_key);
 
-                // export key and write into section
-                {
-                    sprintf(command, "%s --batch --export --armor %s", gpg2_path, sign_key);
+                        unsigned long key_offset = 0, key_length = 0;
 
-                    unsigned long key_offset = 0, key_length = 0;
+                        bool rv = appimage_get_elf_section_offset_and_length(destination, ".sig_key", &key_offset, &key_length);
 
-                    bool rv = appimage_get_elf_section_offset_and_length(destination, ".sig_key", &key_offset, &key_length);
+                        if (verbose) {
+                            printf("key_offset: %lu\n", key_offset);
+                            printf("key_length: %lu\n", key_length);
+                        }
 
-                    if (verbose) {
-                        printf("key_offset: %lu\n", key_offset);
-                        printf("key_length: %lu\n", key_length);
-                    }
+                        if (!rv || key_offset == 0 || key_length == 0) {
+                            die("Could not find section .sig_key in runtime");
+                        }
 
-                    if (!rv || key_offset == 0 || key_length == 0) {
-                        die("Could not find section .sig_key in runtime");
-                    }
+                        fseek(destinationfp, key_offset, SEEK_SET);
 
-                    fseek(destinationfp, key_offset, SEEK_SET);
+                        fp = popen(command, "r");
 
-                    fp = popen(command, "r");
+                        if (fp == NULL)
+                            die("Failed to call gpg[2] to export the signature key");
 
-                    if (fp == NULL)
-                        die("Failed to call gpg[2] to export the signature key");
+                        static const int bufsize = 1024;
+                        char buffer[bufsize];
 
-                    static const int bufsize = 1024;
-                    char buffer[bufsize];
+                        size_t totalBytesRead = 0;
+                        while (!feof(fp)) {
+                            size_t bytesRead = fread(buffer, sizeof(char), bufsize, fp);
+                            totalBytesRead += bytesRead;
 
-                    size_t totalBytesRead = 0;
-                    while (!feof(fp)) {
-                        size_t bytesRead = fread(buffer, sizeof(char), bufsize, fp);
-                        totalBytesRead += bytesRead;
+                            if (totalBytesRead > key_length) {
+                                // read rest of process input to avoid broken pipe error
+                                while (!feof(fp)) {
+                                    fread(buffer, sizeof(char), bufsize, fp);
+                                }
 
-                        if (totalBytesRead > key_length) {
-                            // read rest of process input to avoid broken pipe error
-                            while (!feof(fp)) {
-                                fread(buffer, sizeof(char), bufsize, fp);
+                                pclose(fp);
+                                die("Error: cannot embed key in AppImage: size exceeds reserved ELF section size");
                             }
 
-                            pclose(fp);
-                            die("Error: cannot embed key in AppImage: size exceeds reserved ELF section size");
+                            size_t bytesWritten = fwrite(buffer, sizeof(char), bytesRead, destinationfp);
+
+                            if (bytesRead != bytesWritten) {
+                                char message[128];
+                                sprintf(message, "Error: Bytes read and written differ: %lu != %lu",
+                                    (long unsigned) bytesRead, (long unsigned) bytesWritten);
+                                die(message);
+                            }
                         }
 
-                        size_t bytesWritten = fwrite(buffer, sizeof(char), bytesRead, destinationfp);
+                        int exportexitcode = pclose(fp);
+                        fp = NULL;
 
-                        if (bytesRead != bytesWritten) {
+                        if (exportexitcode != 0) {
                             char message[128];
-                            sprintf(message, "Error: Bytes read and written differ: %lu != %lu",
-                                (long unsigned) bytesRead, (long unsigned) bytesWritten);
+                            sprintf(message, "GPG key export failed: exit code %d", exportexitcode);
                             die(message);
                         }
-                    }
 
-                    int exportexitcode = pclose(fp);
-                    fp = NULL;
-
-                    if (exportexitcode != 0) {
-                        char message[128];
-                        sprintf(message, "GPG key export failed: exit code %d", exportexitcode);
-                        die(message);
+                        fclose(destinationfp);
                     }
-
-                    fclose(destinationfp);
                 }
             }
         }
